Index: code/branches/input/src/orxonox/objects/ParticleProjectile.h
===================================================================
--- code/branches/input/src/orxonox/objects/ParticleProjectile.h	(revision 1629)
+++ code/branches/input/src/orxonox/objects/ParticleProjectile.h	(revision 1629)
@@ -0,0 +1,52 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _ParticleProjectile_H__
+#define _ParticleProjectile_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "BillboardProjectile.h"
+#include "tools/ParticleInterface.h"
+#include "util/Math.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport ParticleProjectile : public BillboardProjectile
+    {
+        public:
+            ParticleProjectile(SpaceShip* owner = 0);
+            virtual ~ParticleProjectile();
+            virtual void changedVisibility();
+
+        private:
+            ParticleInterface* particles_;
+    };
+}
+
+#endif /* _ParticleProjectile_H__ */
Index: code/branches/input/src/orxonox/objects/ParticleSpawner.cc
===================================================================
--- code/branches/input/src/orxonox/objects/ParticleSpawner.cc	(revision 1629)
+++ code/branches/input/src/orxonox/objects/ParticleSpawner.cc	(revision 1629)
@@ -0,0 +1,105 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "ParticleSpawner.h"
+
+#include "core/CoreIncludes.h"
+#include "core/Executor.h"
+#include "tools/ParticleInterface.h"
+#include "GraphicsEngine.h"
+
+namespace orxonox
+{
+    CreateFactory(ParticleSpawner);
+
+    ParticleSpawner::ParticleSpawner()
+    {
+        RegisterObject(ParticleSpawner);
+        this->particle_ = 0;
+    }
+
+    ParticleSpawner::ParticleSpawner(const std::string& templateName, LODParticle::LOD detaillevel, float lifetime, float startdelay, float destroydelay, const Vector3& direction)
+    {
+        RegisterObject(ParticleSpawner);
+        this->setParticle(templateName, detaillevel, lifetime, startdelay, destroydelay, direction);
+    }
+
+    void ParticleSpawner::setParticle(const std::string& templateName, LODParticle::LOD detaillevel, float lifetime, float startdelay, float destroydelay, const Vector3& direction)
+    {
+        ExecutorMember<ParticleSpawner>* executor = createExecutor(createFunctor(&ParticleSpawner::createParticleSpawner));
+        this->destroydelay_ = destroydelay;
+        executor->setDefaultValues(lifetime);
+        this->timer_.setTimer(startdelay, false, this, executor);
+        this->particle_ = new ParticleInterface(templateName, detaillevel);
+        this->particle_->addToSceneNode(this->getNode());
+        this->particle_->setEnabled(false);
+        if (direction != Vector3::ZERO)
+        {
+            this->particle_->getAllEmitters()->setDirection(direction);
+        }
+    }
+
+    ParticleSpawner::~ParticleSpawner()
+    {
+        if (this->isInitialized() && this->particle_)
+        {
+            this->particle_->detachFromSceneNode();
+            delete this->particle_;
+        }
+    };
+
+    void ParticleSpawner::destroy()
+    {
+        this->setPosition(this->getNode()->getParent()->getPosition());
+        this->getNode()->getParent()->removeChild(this->getNode());
+        GraphicsEngine::getSingleton().getSceneManager()->getRootSceneNode()->addChild(this->getNode());
+        if (this->particle_)
+            this->particle_->setEnabled(false);
+        if (!this->timer_.isActive() || this->timer_.getRemainingTime() > this->destroydelay_)
+            this->timer_.setTimer(this->destroydelay_, false, this, createExecutor(createFunctor(&ParticleSpawner::destroyParticleSpawner)));
+    }
+
+    void ParticleSpawner::createParticleSpawner(float lifetime)
+    {
+        this->particle_->setEnabled(true);
+        if (lifetime != 0)
+            this->timer_.setTimer(lifetime, false, this, createExecutor(createFunctor(&ParticleSpawner::destroyParticleSpawner)));
+    }
+
+    void ParticleSpawner::destroyParticleSpawner()
+    {
+        delete this;
+    }
+
+    void ParticleSpawner::setVisible(bool visible)
+    {
+        if (this->particle_)
+            this->particle_->setEnabled(visible);
+    }
+}
Index: code/branches/input/src/orxonox/objects/ParticleSpawner.h
===================================================================
--- code/branches/input/src/orxonox/objects/ParticleSpawner.h	(revision 1629)
+++ code/branches/input/src/orxonox/objects/ParticleSpawner.h	(revision 1629)
@@ -0,0 +1,63 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _ParticleSpawner_H__
+#define _ParticleSpawner_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "WorldEntity.h"
+#include "tools/Timer.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport ParticleSpawner : public WorldEntity
+    {
+        public:
+            ParticleSpawner();
+            ParticleSpawner(const std::string& templateName, LODParticle::LOD detaillevel, float lifetime = 0, float startdelay = 0, float destroydelay = 0, const Vector3& direction = Vector3::ZERO);
+            virtual ~ParticleSpawner();
+            void destroy();
+
+            void setParticle(const std::string& templateName, LODParticle::LOD detaillevel, float lifetime = 0, float startdelay = 0, float destroydelay = 0, const Vector3& direction = Vector3::ZERO);
+            inline ParticleInterface* getParticleInterface() const
+                { return this->particle_; }
+
+            void setVisible(bool visible);
+
+        private:
+            void createParticleSpawner(float lifetime);
+            void destroyParticleSpawner();
+
+            Timer<ParticleSpawner> timer_;
+            ParticleInterface* particle_;
+            float destroydelay_;
+    };
+}
+
+#endif /* _ParticleSpawner_H__ */
Index: code/branches/input/src/orxonox/objects/Projectile.cc
===================================================================
--- code/branches/input/src/orxonox/objects/Projectile.cc	(revision 1623)
+++ code/branches/input/src/orxonox/objects/Projectile.cc	(revision 1629)
@@ -35,25 +35,21 @@
 #include "core/Executor.h"
 #include "core/ConfigValueIncludes.h"
+#include "tools/ParticleInterface.h"
 
-#include "SpaceShip.h"
-#include "Explosion.h"
+#include "SpaceShipAI.h"
+#include "ParticleSpawner.h"
 #include "Model.h"
 
 namespace orxonox
 {
-    CreateFactory(Projectile);
+    float Projectile::speed_ = 5000;
 
-    float Projectile::speed_ = 0;
-
-    Projectile::Projectile(SpaceShip* owner) :
-      owner_(owner)
+    Projectile::Projectile(SpaceShip* owner) : owner_(owner)
     {
         RegisterObject(Projectile);
 
         this->setConfigValues();
-
-        this->billboard_.setBillboardSet("Examples/Flare", ColourValue(1.0, 1.0, 0.5), 1);
-        this->attachObject(this->billboard_.getBillboardSet());
-        this->scale(0.5);
+        this->explosionTemplateName_ = "Orxonox/explosion3";
+        this->smokeTemplateName_ = "Orxonox/smoke4";
 
         if (this->owner_)
@@ -63,9 +59,8 @@
             this->setPosition(this->owner_->getPosition());
             this->translate(Vector3(55, 0, 0), Ogre::Node::TS_LOCAL);
-            this->setVelocity(Vector3(1, 0, 0) * this->speed_);
+            this->setVelocity(this->owner_->getInitialDir() * this->speed_);
         }
 
         this->destroyTimer_.setTimer(this->lifetime_, false, this, createExecutor(createFunctor(&Projectile::destroyObject)));
-//        COUT(3) << this->classID << std::endl;
     }
 
@@ -76,8 +71,10 @@
     void Projectile::setConfigValues()
     {
-        SetConfigValue(lifetime_, 10.0).description("The time in seconds a projectile stays alive");
-        SetConfigValue(speed_, 2000.0).description("The speed of a projectile in units per second");
+        SetConfigValue(damage_, 15.0).description("The damage caused by the projectile");
+        SetConfigValue(lifetime_, 4.0).description("The time in seconds a projectile stays alive");
+        SetConfigValue(speed_, 5000.0).description("The speed of a projectile in units per second");
 
-        this->setVelocity(Vector3(1, 0, 0) * this->speed_);
+	if(this->owner_)
+          this->setVelocity(this->owner_->getInitialDir() * this->speed_);
     }
 
@@ -85,4 +82,7 @@
     {
         WorldEntity::tick(dt);
+
+        if (!this->isActive())
+            return;
 
         float radius;
@@ -95,6 +95,14 @@
                 if (this->getPosition().squaredDistance(it->getPosition()) <= (radius*radius))
                 {
-                    Explosion *exp = new Explosion(this);
-                    exp->create();
+                    // hit
+                    if (it->isA(Class(SpaceShipAI)))
+                        ((SpaceShipAI*)(*it))->damage(this->damage_);
+                    ParticleSpawner* explosion = new ParticleSpawner(this->explosionTemplateName_, LODParticle::low, 2.0);
+                    explosion->setPosition(this->getPosition());
+                    explosion->create();
+                    ParticleSpawner* smoke = new ParticleSpawner(this->smokeTemplateName_, LODParticle::normal, 2.0, 0.0);
+                    smoke->setPosition(this->getPosition());
+//                    smoke->getParticleInterface()->setSpeedFactor(3.0);
+                    smoke->create();
                     delete this;
                     return;
@@ -108,8 +116,3 @@
         delete this;
     }
-
-    void Projectile::setColour(const ColourValue& colour)
-    {
-        this->billboard_.getBillboardSet()->getBillboard(0)->setColour(colour);
-    }
 }
Index: code/branches/input/src/orxonox/objects/Projectile.h
===================================================================
--- code/branches/input/src/orxonox/objects/Projectile.h	(revision 1623)
+++ code/branches/input/src/orxonox/objects/Projectile.h	(revision 1629)
@@ -33,7 +33,5 @@
 
 #include "WorldEntity.h"
-#include "../tools/BillboardSet.h"
-#include "../tools/Timer.h"
-#include "util/Math.h"
+#include "tools/Timer.h"
 
 namespace orxonox
@@ -42,11 +40,8 @@
     {
         public:
-            Projectile(SpaceShip* owner = 0);
             virtual ~Projectile();
             void setConfigValues();
             void destroyObject();
             virtual void tick(float dt);
-            virtual bool create(){return WorldEntity::create();}
-            void setColour(const ColourValue& colour);
 
             static float getSpeed()
@@ -54,10 +49,13 @@
 
         protected:
+            Projectile(SpaceShip* owner = 0);
             SpaceShip* owner_;
 
         private:
-            BillboardSet billboard_;
+            std::string explosionTemplateName_;
+            std::string smokeTemplateName_;
             static float speed_;
             float lifetime_;
+            float damage_;
             Timer<Projectile> destroyTimer_;
     };
Index: code/branches/input/src/orxonox/objects/RotatingProjectile.cc
===================================================================
--- code/branches/input/src/orxonox/objects/RotatingProjectile.cc	(revision 1623)
+++ code/branches/input/src/orxonox/objects/RotatingProjectile.cc	(revision 1629)
@@ -37,5 +37,5 @@
     CreateFactory(RotatingProjectile);
 
-    RotatingProjectile::RotatingProjectile(SpaceShip* owner) : Projectile(owner)
+    RotatingProjectile::RotatingProjectile(SpaceShip* owner) : BillboardProjectile(owner)
     {
         RegisterObject(RotatingProjectile);
@@ -73,10 +73,20 @@
     void RotatingProjectile::tick(float dt)
     {
-        this->time_ += dt;
+        if (this->isActive())
+        {
+            this->time_ += dt;
 
-        this->rotatingNode1_->setPosition(0, 50 * sin(this->time_ * 20), 50 * cos(this->time_ * 20));
-        this->rotatingNode2_->setPosition(0, -50 * sin(this->time_ * 20), -50 * cos(this->time_ * 20));
+            this->rotatingNode1_->setPosition(0, 50 * sin(this->time_ * 20), 50 * cos(this->time_ * 20));
+            this->rotatingNode2_->setPosition(0, -50 * sin(this->time_ * 20), -50 * cos(this->time_ * 20));
+        }
 
         Projectile::tick(dt);
     }
+
+    void RotatingProjectile::changedVisibility()
+    {
+        BillboardProjectile::changedVisibility();
+        this->rotatingBillboard1_.setVisible(this->isVisible());
+        this->rotatingBillboard2_.setVisible(this->isVisible());
+    }
 }
Index: code/branches/input/src/orxonox/objects/RotatingProjectile.h
===================================================================
--- code/branches/input/src/orxonox/objects/RotatingProjectile.h	(revision 1623)
+++ code/branches/input/src/orxonox/objects/RotatingProjectile.h	(revision 1629)
@@ -2,11 +2,11 @@
 #define _RotatingProjectile_H__
 
-#include "../OrxonoxPrereqs.h"
+#include "OrxonoxPrereqs.h"
 #include "util/Math.h"
-#include "Projectile.h"
+#include "BillboardProjectile.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport RotatingProjectile : public Projectile/*, public network::Synchronisable*/
+    class _OrxonoxExport RotatingProjectile : public BillboardProjectile
     {
         public:
@@ -15,5 +15,5 @@
             void setConfigValues();
             virtual void tick(float dt);
-            virtual bool create(){return Projectile::create();}
+            virtual void changedVisibility();
 
         private:
Index: code/branches/input/src/orxonox/objects/Skybox.cc
===================================================================
--- code/branches/input/src/orxonox/objects/Skybox.cc	(revision 1623)
+++ code/branches/input/src/orxonox/objects/Skybox.cc	(revision 1629)
@@ -54,24 +54,14 @@
     }
 
-    void Skybox::loadParams(TiXmlElement* xmlElem)
+    void Skybox::setSkybox(const std::string& skyboxname)
     {
-    	if (xmlElem->Attribute("src"))
-    	{
-    		skyboxSrc_ = xmlElem->Attribute("src");
-        this->create();
+    	GraphicsEngine::getSingleton().getSceneManager()->setSkyBox(true, skyboxname);
+    }
 
-	    	COUT(4) << "Loader: Set skybox: "<< skyboxSrc_ << std::endl << std::endl;
-    	}
-   }
+    void Skybox::setSkyboxSrc(const std::string& src)
+    {
+        this->skyboxSrc_ = src;
+    }
 
-   void Skybox::setSkybox(const std::string& skyboxname)
-   {
-    	GraphicsEngine::getSingleton().getSceneManager()->setSkyBox(true, skyboxname);
-   }
-
-   void Skybox::setSkyboxSrc(const std::string& src){
-     skyboxSrc_ = src;
-   }
-   
     /**
         @brief XML loading and saving.
@@ -87,13 +77,20 @@
         create();
     }
-    
-    bool Skybox::create(){
-      this->setSkybox(skyboxSrc_);
-      return Synchronisable::create();
+
+    bool Skybox::create()
+    {
+        this->setSkybox(this->skyboxSrc_);
+        return Synchronisable::create();
     }
-    
-    void Skybox::registerAllVariables(){
-      registerVar(&skyboxSrc_, skyboxSrc_.length()+1 ,network::STRING);
+
+    void Skybox::registerAllVariables()
+    {
+        registerVar(&skyboxSrc_, skyboxSrc_.length()+1 ,network::STRING);
     }
-    
+
+    void Skybox::changedVisibility()
+    {
+        BaseObject::changedVisibility();
+        GraphicsEngine::getSingleton().getSceneManager()->setSkyBox(this->isVisible(), this->skyboxSrc_);
+    }
 }
Index: code/branches/input/src/orxonox/objects/Skybox.h
===================================================================
--- code/branches/input/src/orxonox/objects/Skybox.h	(revision 1623)
+++ code/branches/input/src/orxonox/objects/Skybox.h	(revision 1629)
@@ -43,8 +43,8 @@
             virtual ~Skybox();
 
-            void loadParams(TiXmlElement* xmlElem);
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void changedVisibility();
             void setSkybox(const std::string& skyboxname);
-            
+
             virtual bool create();
             void registerAllVariables();
